hex

\ delete this to make headerless tokens until external below
external

fcode-version1

\ ========================================================================================
\ Constants

: h#100 100 ;
: h#fff fff ;
: h#-1000 -1000 ;

: "map" " map" ;

: "xcoff-loader" " xcoff-loader" ;

40 constant w___
28 constant _i_g
10 constant __m_

\ ========================================================================================
\ Words for local variables which are not supported by toke yet.

: { ;
: ... ;
: } ;
: -> ;
: local_0 ;
: local_1 ;
: local_2 ;
: local_3 ;
: local_4 ;
: local_5 ;

\ ========================================================================================
\ Dependencies not included

1 constant const_170c \ is 64 bit CPU (project "c3" instead of project "Core2001")

defer claim-mem
\ " ..." to claim-mem

defer $sync-cache

" _mmu-ihandle" eval value _mmu-ihandle

: do-map "map" _mmu-ihandle $call-method ;

: (abort") ( doabort abortmessage) ;

: load_base " load_base" eval ;

: filll ( address size long-value ) ; \ fill range with long-value

: ci-regs ;
: dreg! ci-regs + 2! ; \ 64-bit registers
: reg! ci-regs + ! ; \ 32-bit registers

: spsv 8      ; \ offset for stack pointer (same as r1)
: tocsv 16    ; \ offset for TOC register (same as r2)
: argsv 40    ; \ offset for argument registers (same as r5)
: crsv 130    ; \ offset for condition register
: srr0sv 110  ; \ offset for srr0
: srr1sv 0118 ; \ offset for srr1 register
: dreg! ;

: cientry ;

: msr@ ;  \ get 32-bit msr register
: msrd@ ; \ get 64-bit msr register

variable state-valid

: ?state-valid
	state-valid @ 0= " state not valid"	(abort") ;					

\ ========================================================================================
\ code

"xcoff-loader"
device-name

headers
struct
/w field >xf.magic
/w field >xf.nscns
/l
+
/l
+
/l
+
/w
+
/w
+
constant filehdr.size
struct
/w field >xo.magic
/w
+
/l field >xo.tsize
/l field >xo.dsize
/l field >xo.bsize
/l field >xo.entry
/l
+
/l
+
/l
+
/w
+
/w field >xo.sntext
/w field >xo.sndata
/w
+
/w
+
/w field >xo.snbss
1c
+
constant opthdr.size
struct
8 field >xs.name
/l field >xs.paddr
/l field >xs.vaddr
/l field >xs.size
/l field >xs.scnptr
/l
+
/l
+
/w
+
/w
+
/l
+
constant scthdr.size
variable $entry
0 value file-base
0 value bss-top

: loadsct
	{ local_0 local_1 ; ... }
	local_1
	>xs.scnptr
	@
	file-base
	+
	-> local_2
	local_1
	>xs.paddr
	@
	-> local_3
	local_1
	>xs.size
	@
	-> local_4
	local_4
	if
		local_3
		h#-1000
		and
		local_4
		h#fff
		+
		h#-1000
		and
		2dup
		0
		claim-mem
		drop
		over
		-rot
		__m_
		do-map
		local_2
		local_3
		local_4
		move
		local_0
		if
			local_3
			local_4
			$sync-cache
		then
	then
	;


: clearsct
	{ local_0 ; ... }
	local_0
	>xs.paddr
	@
	-> local_1
	local_0
	>xs.size
	@
	8000
	+
	-> local_2
	local_1
	h#fff
	+
	h#-1000
	and
	local_1
	local_2
	+
	h#fff
	+
	h#-1000
	and
	over
	-
	dup
	if
		2dup
		0
		claim-mem
		drop
		2dup
		over
		-rot
		__m_
		do-map
	then
	+
	to bss-top
	local_1
	local_2
	erase
	;


: load-xcoff
	{ local_0 ; ... }
	base
	@
	-> local_5
	hex
	local_0
	to file-base
	local_0
	>xf.magic
	w@
	1df
	<>
	" bad f_magic"
	(abort")
	local_0
	>xf.nscns
	w@
	-> local_1
	local_0
	filehdr.size
	+
	-> local_2
	local_2
	>xo.magic
	w@
	10b
	<>
	" bad o_magic"
	(abort")
	cr
	." tsize="
	local_2
	>xo.tsize
	?
	." dsize="
	local_2
	>xo.dsize
	?
	." bsize="
	local_2
	>xo.bsize
	?
	." entry="
	local_2
	>xo.entry
	@
	dup
	$entry
	!
	u.
	cr
	local_2
	opthdr.size
	+
	-> local_4
	." SECTIONS:"
	cr
	local_4
	-> local_3
	local_1
	0
	do
		8
		0
		do
			local_3
			>xs.name
			i
			+
			c@
			?dup
			if
				emit
			else
				space
			then
		loop
		space
		local_3
		>xs.paddr
		@
		8
		u.r
		space
		local_3
		>xs.vaddr
		@
		8
		u.r
		space
		local_3
		>xs.size
		@
		8
		u.r
		space
		local_3
		>xs.scnptr
		@
		8
		u.r
		cr
		local_3
		scthdr.size
		+
		-> local_3
	loop
	local_2
	>xo.sntext
	w@
	1-
	scthdr.size
	*
	local_4
	+
	-> local_3
	." loading .text"
	true
	local_3
	loadsct
	." , done.."
	cr
	local_2
	>xo.sndata
	w@
	1-
	scthdr.size
	*
	local_4
	+
	-> local_3
	." loading .data"
	false
	local_3
	loadsct
	." , done.."
	cr
	local_2
	>xo.snbss
	w@
	1-
	scthdr.size
	*
	local_4
	+
	-> local_3
	." clearing .bss"
	local_3
	clearsct
	." , done.."
	cr
	local_5
	base
	!
	;


: toc@
	$entry
	@
	cell+
	@
	;


: srr0@
	$entry
	@
	@
	;



external
: open
	true
	;


: close
	;


: init-program
	load_base
	load-xcoff
	ci-regs
	h#100
	0
	filll
	const_170c
	if
		bss-top
		100
		-
		0
		spsv
		dreg!
		toc@
		0
		tocsv
		dreg!
		['] cientry
		0
		argsv
		dreg!
		0
		crsv
		reg!
		srr0@
		0
		srr0sv
		dreg!
		msrd@
		swap
		7fff
		and
		swap
		srr1sv
		dreg!
	else
		bss-top
		100
		-
		spsv
		reg!
		toc@
		tocsv
		reg!
		['] cientry
		argsv
		reg!
		0
		crsv
		reg!
		srr0@
		srr0sv
		reg!
		msr@
		7fff
		and
		srr1sv
		reg!
	then
	state-valid
	on
	?state-valid
	;

finish-device

fcode-end
